package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.model.platform.MissResourceModel;
import cn.estsh.i3plus.pojo.platform.bean.SysLocaleResource;
import cn.estsh.i3plus.pojo.platform.bean.SysMenu;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 系统语言资源接口
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2018-11-12 13:32
 * @Modify:
 **/
public interface ISysLocaleResourceService {

    @ApiOperation(value = "新增系统资源",notes = "新增系统资源")
    SysLocaleResource insertSysLocaleResource(SysLocaleResource sysLocaleResource);

    @ApiOperation(value = "保存系统资源",notes = "保存系统资源")
    List<SysLocaleResource> saveSysLocaleResource(List<SysLocaleResource> list);

    @ApiOperation(value = "修改系统资源",notes = "修改系统资源")
    void updateSysLocaleResource(SysLocaleResource sysLocaleResource);

    @ApiOperation(value = "根据id删除系统资源",notes = "根据id删除系统资源")
    void deleteSysLocaleResourceById(Long id);

    @ApiOperation(value = "查询全部系统资源",notes = "查询全部系统资源")
    List<SysLocaleResource> listSysLocaleResource();

    @ApiOperation(value = "系统资源复杂查询，分页，排序",notes = "系统资源复杂查询，分页，排序")
    ListPager querySysLocaleResourceByPager(SysLocaleResource sysLocaleResource, Pager pager);

    @ApiOperation(value = "根据id批量删除",notes = "根据id批量删除")
    void deleteSysLocaleResourceByIds(Long[] ids);

    @ApiOperation(value = "批量添加")
    void insertSysLocaleResourceList(List<SysLocaleResource> sysLocaleResources);

    @ApiOperation(value = "根据语言code和资源key查询资源")
    SysLocaleResource getSysLocaleResourceByLanguageCodeAndResKey(String languageCode,String resKey);

    @ApiOperation(value = "根据资源key查询资源")
    List<SysLocaleResource> findSysLocaleResourceByResKey(String resKey);

    @ApiOperation(value = "根据条件查询资源")
    List<SysLocaleResource> findSysLocaleResource(SysLocaleResource sysLocaleResource);

    @ApiOperation(value = "根据id查询资源")
    SysLocaleResource getSysLocaleResourceById(Long id);

    @ApiOperation(value = "功能权限国际化")
    List<SysMenu> tranSysMenu(List<SysMenu> menuList);

    @ApiOperation(value = "删除所有资源")
    void deleteSysLocaleResourceAll();

    /***************************** 缺失资源管理  ******************************/

    /**
     * 查询指定数量的缺失资源
     * @param num 数量
     * @return
     */
    @ApiOperation(value = "查询指定数量的缺失资源")
    List<MissResourceModel> findMissResourceModelByTop(int num);

    /**
     * 缺失资源key
     * @param keys
     */
    @ApiOperation(value = "根据key删除缺失资源信息")
    void deleteInValidMissResourceByKeys(String[] keys);

    /**
     * 批量转换缺失资源
     * @param missResourceModelList 缺失资源信息
     * @param userName 用户名称
     */
    @ApiOperation(value = "批量转换缺失资源")
    void doConversionMissResourceByKeys(List<MissResourceModel> missResourceModelList,String userName) ;

}
