package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.platform.bean.TestTransUser;
import io.swagger.annotations.ApiOperation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2019-04-29 17:16
 * @Modify:
 **/
public interface ITestTransService {

    @ApiOperation(value = "两类dao混用，测试entityManager")
    void testListTran(int type,String name);

    @ApiOperation(value = "自定义dao混用")
    void testTran();

    @ApiOperation(value = "测试缓存事务")
    void testRedisTrans(String name, String val);

    void insertRedis();

    void selectRedis();

    /******************** 读写分离部分测试 **********************/

    @ApiOperation(value = "读写分离测试读")
    @Transactional
    List<TestTransUser> listRead();

    @ApiOperation(value = "读写分离测试写")
    @Transactional
    void write();

    @ApiOperation(value = "读写分离测试读写-写事务")
    void transReadWrite();

    @ApiOperation(value = "读写分离测试读写-读事务")
    void readWrite();

    /******************** 事务机制部分demo **********************/

    //@ApiOperation(value = "开始事务，执行过程中休眠seconds秒")
    //void readTransTest(int seconds);

    //void testListTranSec(int type,String name);

    @ApiOperation(value = "更新对象")
    void updateTestTransUser(String name, double salary);

    @ApiOperation(value = "新增对象")
    void insertTestTransUser(String name,double salary);

    /**
     * type == 1 按主键删除
     * type == 2 按name删除
     */
    @ApiOperation(value = "删除对象")
    void deleteTestTransUser(String name);



    @ApiOperation(value = "第一类丢失更新")
    void updateLost(String name, int time, boolean execp);

    @ApiOperation(value = "第二类丢失更新")
    void updateLostTrans(String name,double salary, int time, boolean execp);

    @ApiOperation(value = "脏读模拟A")
    void writeDirtyA(long id);

    @ApiOperation(value = "脏读模拟B")
    void writeDirtyB(long id);

    @ApiOperation(value = "不可重复读A")
    void writeRepeatA(long id);

    @ApiOperation(value = "不可重复读B")
    void writeRepeatB(long id);

    @ApiOperation(value = "幻读模拟A")
    void writePhantomA(long id,boolean listOrDelete);

    @ApiOperation(value = "幻读模拟B")
    void writePhantomB();

    @ApiOperation(value = "创建新事务")
    void writeRequireNew();

    @ApiOperation(value = "创建新事务-子方法")
    void writeRequireNewMore();

    @ApiOperation(value = "没有事务抛出异常")
    void writeTransMandatory();

    @ApiOperation(value = "没有事务抛出异常-子方法")
    void writeTransMandatoryMore();

    @ApiOperation(value = "乐观锁 Optimistic lockA")
    void writeOptimisticA(long id,int type);

    @ApiOperation(value = "乐观锁 Optimistic lockB")
    void writeOptimisticB(long id,int type);

    @ApiOperation(value = "悲观锁 pessimistic lockA")
    void writePessimisticA(long id,int type);

    @ApiOperation(value = "悲观锁 pessimistic lockB")
    void writePessimisticB(long id,int type);

    @ApiOperation(value = "常见事务处理-可能出现并发问题")
    void writePatternWrong(long id,double salary);

    @ApiOperation(value = "事务模式-线程锁")
    void writePatternSynchron(long id,double salary);

    @ApiOperation(value = "事务模式-乐观锁")
    void writePatternOpti(long id,double salary);

    @ApiOperation(value = "事务模式-悲观锁")
    void writePatternPessi(long id,double salary);

    @ApiOperation(value = "属性更新")
    void writePatternParamUpdate(long id,double salary);
}
