package cn.estsh.i3plus.core.apiservice.controller.cloud;

import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.model.softswitch.SuitImppCloudModel;
import cn.estsh.impp.framework.base.controller.CoreBaseController;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description :
 * 微服务白名单调用接口
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-4-18 上午10:41
 * @Modify:
 **/
@RestController
@Api(tags = "Cloud 白名单服务")
@RequestMapping("/impp/white/cloud")
public class WhiteCloudController extends CoreBaseController {
    private static final Logger LOGGER = LoggerFactory.getLogger(WhiteCloudController.class);

    @PostMapping(value = "/softwitch/result")
    @ApiOperation(value = "数据源列表", notes = "获取服务的数据源列表")
    public BaseResultBean softwitchResult(@RequestBody SuitImppCloudModel model) {
        LOGGER.info("Cloud Message : {}", model);
        return ResultBean.success("操作成功")
                .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                .setMsg("这是 Core 返回的一段数据 -> " + System.currentTimeMillis());
    }

}
