package cn.estsh.i3plus.core.apiservice.dao;

import cn.estsh.i3plus.pojo.platform.bean.*;

import java.util.List;

/**
 * @Description : 用户权限
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-25 20:24
 * @Modify :
 **/
public interface IUserPermissionDao {

    /**
     * 查询用户所有部门
     * @param userInfo 用户信息
     * @return 查询结果
     */
    List<SysDepartment> findDepartmentByUser(SysUserInfo userInfo);

    /**
     * 查询用户所有角色
     * @param user 用户
     * @return 查询结果
     */
    List<SysRole> findSysRoleByUser(SysUser user);

    /**
     * 查询用户所有功能权限
     * @param user 用户
     * @return 查询结果
     */
    List<SysMenu> findSysMenuByUser(SysUser user);

    /**
     * 根据角色获取 目录
     * @param roleId 角色ID集合
     * @return 获取有效的目录信息
     */
    List<SysMenu> findSysMenuByInRoleId(Long ... roleId);

    /**
     * 根据角色获取 目录
     * @param roleId 角色ID集合
     * @return 获取有效的目录信息
     */
    List<SysMenu> findHomeMenuByInRoleId(Long ... roleId);

    /**
     * 查询用户所有功能权限 Tree
     * @param user 用户
     * @return 查询结果
     */
    List<SysMenu> findSysMenuByUserTree(SysUser user);

    /**
     * 查询用户所有岗位
     * @param userInfo 用户信息
     * @return 查询结果
     */
    List<SysPosition> findPositionByUser(SysUserInfo userInfo);

}
