package cn.estsh.i3plus.core.apiservice.schedulejob;

import cn.estsh.i3plus.core.api.iservice.base.ISysLogService;
import cn.estsh.i3plus.core.apiservice.serviceimpl.base.SysLogElasticSearchService;
import cn.estsh.i3plus.core.apiservice.serviceimpl.base.SysLogMongoService;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.platform.plugin.elasticsearch.ElasticSearchTool;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogException;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogOperate;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogSystem;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogTaskTime;
import cn.estsh.impp.framework.base.schedule.BaseImppScheduleJob;
import cn.estsh.impp.framework.boot.init.ApplicationProperties;
import cn.estsh.impp.framework.boot.util.RedisCacheTool;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.JobExecutionContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @Description :
 * @Reference : 日志清除
 * @Author : yunhao
 * @CreateDate : 2019-07-04 19:13
 * @Modify:
 **/
@Component
@DisallowConcurrentExecution
public class CoreLogClearJob extends BaseImppScheduleJob {

    public static final Logger LOGGER = LoggerFactory.getLogger(CoreLogClearJob.class);
    private static final long serialVersionUID = 2706787898778108791L;

    public CoreLogClearJob() {
        super(CoreLogClearJob.class, "日志清除");
    }

    @Autowired
    private ISysLogService logService;

    @Override
    public void executeImppJob(JobExecutionContext context, ApplicationProperties applicationProperties) {
        int to = RedisCacheTool.getSysConfigIntVal(CommonConstWords.LOG_STORAGE_DAYS, CommonConstWords.LOG_STORAGE_DAYS_DEFAULT);
        Date thisTime = new Date();
        String startTime = TimeTool.getToday(TimeTool.getDateBefore(thisTime, to)) + " 00:00:00";
        String endTime = TimeTool.getToday(TimeTool.getDateBefore(thisTime, to)) + " 23:59:59";
        logService.actionCleanLog(startTime,endTime);
    }

}
