package cn.estsh.i3plus.core.apiservice.schedulejob;

import cn.estsh.i3plus.core.api.iservice.busi.ISysMessageService;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysMessage;
import cn.estsh.impp.framework.base.schedule.BaseImppScheduleJob;
import cn.estsh.impp.framework.boot.init.ApplicationProperties;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @Description :  定时任务
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-30 13:25
 * @Modify:
 **/
@DisallowConcurrentExecution
@ApiOperation("定时任务demo")
public class DemoJob extends BaseImppScheduleJob {

    private static final long serialVersionUID = 2582480740831583839L;

    public DemoJob() {
        super(DemoJob.class,"定时任务demo");
    }

    @Autowired
    private ISysMessageService sysMessageService;

    @Override
    public void executeImppJob(JobExecutionContext context, ApplicationProperties applicationProperties) {
//        if(getJobParam() != null && "error".equals(getJobParam())){
//            throw ImppExceptionBuilder.newInstance()
//                    .setSystemID(CommonEnumUtil.SOFT_TYPE.CORE.getCode())
//                    .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
//                    .setErrorDetail("定时任务异常测试！")
//                    .setErrorSolution("请检查异常通知邮件")
//                    .buildSearch();
//        }
        sysMessageService.querySysMessageByPager(new SysMessage(),new Pager(10,10));

        try {
            if(getJobParam() != null && StringUtils.isNotBlank(getJobParam())) {
                Thread.sleep(Long.parseLong(getJobParam())*1000);
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        LOGGER = getJobLogger();
        LOGGER.debug("debug /////BaseImppScheduleJob/// ///////projectName：{},port:{}",
                applicationProperties.getApplicationName(),
                applicationProperties.getServerPort());
        LOGGER.info("info ///////////BaseImppScheduleJob// ////projectName：{},port:{}",
                applicationProperties.getApplicationName(),
                applicationProperties.getServerPort());
        LOGGER.warn("warn /////////BaseImppScheduleJob////////////////////projectName：{},port:{}",
                applicationProperties.getApplicationName(),
                applicationProperties.getServerPort());
        LOGGER.error("error ////////////BaseImppScheduleJob////////////////////projectName：{},port:{}",
            applicationProperties.getApplicationName(),
                applicationProperties.getServerPort());
    }
}
