//package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;
//
//import cn.estsh.i3plus.core.api.iservice.busi.IBusiCacheService;
//import cn.estsh.i3plus.core.api.iservice.busi.ISysPositionService;
//import cn.estsh.i3plus.core.api.iservice.busi.ISysRoleService;
//import cn.estsh.i3plus.platform.common.util.CommonConstWords;
//import cn.estsh.i3plus.pojo.platform.bean.*;
//import cn.estsh.impp.framework.boot.util.ImppRedis;
//import com.alibaba.fastjson.JSON;
//import com.alibaba.fastjson.TypeReference;
//import org.apache.commons.collections.CollectionUtils;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.stereotype.Service;
//
//import javax.annotation.Resource;
//import java.util.*;
//
///**
// * @Description :
// * @Reference :
// * @Author : wei.peng
// * @CreateDate : 20-5-6 下午2:58
// * @Modify:
// **/
//@Service
//public class BusiCacheService implements IBusiCacheService {
//    public static final Logger LOGGER = LoggerFactory.getLogger(BusiCacheService.class);
//
//    @Autowired
//    private ISysPositionService positionService;
//
//    @Autowired
//    private ISysRoleService roleService;
//
//    @Resource(name= CommonConstWords.IMPP_REDIS_RES)
//    private ImppRedis redisRes;
//
//    /** Redis 存储Key */
//    private static final String CACHE_ALL_POSITION = CommonConstWords.REDIS_PREFIX_CACHE_POSITION + ":LIST_ALL";
//    private static final String CACHE_ALL_ROLE = CommonConstWords.REDIS_PREFIX_CACHE_ROLE + ":LIST_ALL";
//
//    @Override
//    public void reloadCache() {
//        LOGGER.info("加载 SysPosition 信息");
//        reloadSysPosition();
//        LOGGER.info("加载 SysPosition 信息完成");
//
//        LOGGER.info("加载 SysRole 信息");
//        reloadSysRole();
//        LOGGER.info("加载 SysRole 信息完成");
//    }
//
//    @Override
//    public void reloadSysPosition() {
//        List<SysPosition> positions = positionService.findSysPositionAll();
//        Map<String,SysPosition> positionMap = new HashMap<>();
//
//        if(CollectionUtils.isNotEmpty(positions)){
//            for (SysPosition position : positions) {
//                positionMap.put(position.getId().toString(),position);
//            }
//        }
//
//        redisRes.deleteKey(CACHE_ALL_POSITION);
//        redisRes.putHashMap(CACHE_ALL_POSITION, positionMap, -1);
//    }
//
//    @Override
//    public List<SysPosition> findSysPositionAll() {
//        try {
//            Object redisValue = redisRes.getObject(CACHE_ALL_POSITION);
//            if(Objects.nonNull(redisValue)){
//                HashMap<Long,SysPosition> positionHashMap = JSON.parseObject(redisValue.toString(), new TypeReference<HashMap<Long,SysPosition>>() {});
//                return (List<SysPosition>) positionHashMap.values();
//            }
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//        return null;
//    }
//
//    @Override
//    public SysPosition getSysPositionById(Long id) {
//        try {
//            List<SysPosition> positions = findSysPositionAll();
//            if(Objects.nonNull(positions)){
//                for (SysPosition position : positions) {
//                    if (id.equals(position.getId())){
//                        return position;
//                    }
//                }
//            }
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//        return null;
//    }
//
//    @Override
//    public List<SysPosition> findSysPositionByIds(Long... ids) {
//        try {
//            List<SysPosition> positions = findSysPositionAll();
//            if(Objects.nonNull(positions)){
//                List<SysPosition> result = new ArrayList<>();
//                for (SysPosition position : positions) {
//                    for (Long key : ids) {
//                        if (key.equals(position.getId())){
//                            result.add(position);
//                        }
//                    }
//                }
//                return result;
//            }
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//        return null;
//    }
//
//    @Override
//    public List<SysPosition> findSysPositionByRefs(List<SysRefUserPosition> refUserPositionList) {
//        if(CollectionUtils.isNotEmpty(refUserPositionList)){
//            List<Long> ids = new ArrayList<>();
//            for (SysRefUserPosition ref : refUserPositionList) {
//                ids.add(ref.getPositionId());
//            }
//            return findSysPositionByIds(ids.toArray(new Long[ids.size()]));
//        }
//        return null;
//    }
//
//
//
//
//    @Override
//    public void reloadSysRole() {
//        List<SysRole> positions = roleService.findSysRoleAll();
//        Map<String,SysRole> positionMap = new HashMap<>();
//
//        if(CollectionUtils.isNotEmpty(positions)){
//            for (SysRole position : positions) {
//                positionMap.put(position.getId().toString(),position);
//            }
//        }
//
//        redisRes.deleteKey(CACHE_ALL_ROLE);
//        redisRes.putHashMap(CACHE_ALL_ROLE, positionMap, -1);
//    }
//
//    @Override
//    public List<SysRole> findSysRoleAll() {
//        try {
//            Object redisValue = redisRes.getObject(CACHE_ALL_ROLE);
//            if(Objects.nonNull(redisValue)){
//                HashMap<Long,SysRole> positionHashMap = JSON.parseObject(redisValue.toString(), new TypeReference<HashMap<Long,SysRole>>() {});
//                return (List<SysRole>) positionHashMap.values();
//            }
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//        return null;
//    }
//
//    @Override
//    public List<SysRole> findSysRoleByIds(Long... ids) {
//        try {
//            List<SysRole> positions = findSysRoleAll();
//            if(Objects.nonNull(positions)){
//                List<SysRole> result = new ArrayList<>();
//                for (SysRole position : positions) {
//                    for (Long key : ids) {
//                        if (key.equals(position.getId())){
//                            result.add(position);
//                        }
//                    }
//                }
//                return result;
//            }
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//        return null;
//    }
//
//    @Override
//    public List<SysRole> findSysRoleByRefs(List<SysRefUserRole> refUserRoleList) {
//        if(CollectionUtils.isNotEmpty(refUserRoleList)){
//            List<Long> ids = new ArrayList<>();
//            for (SysRefUserRole ref : refUserRoleList) {
//                ids.add(ref.getRoleId());
//            }
//            return findSysRoleByIds(ids.toArray(new Long[ids.size()]));
//        }
//        return null;
//    }
//
//}
