package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ILicenseClickService;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.impp.framework.boot.license.ImppLicenseTool;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.ImppEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.platform.repository.SysOrganizeRepository;
import cn.estsh.i3plus.pojo.platform.repository.SysUserInfoRepository;
import org.apache.shiro.web.session.mgt.DefaultWebSessionManager;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-3-23 下午5:16
 * @Modify:
 **/
@Service
public class LicenseClickService implements ILicenseClickService {

    private static final Logger LOGGER = LoggerFactory.getLogger(LicenseClickService.class);

    @Autowired
    private SysUserInfoRepository userInfoRDao;

    @Autowired
    private SysOrganizeRepository organizeRDao;

    @Resource(name = CommonConstWords.IMPP_BEAN_SESSION_MANAGER)
    private DefaultWebSessionManager webSessionManager;

    @Override
    public void checkLicenseNumberUser() {
        int count = userInfoRDao.findByHqlWhereCount(DdlPackBean.getDdlPackBean());
        ImppLicenseTool.checkUser(count);
    }

    @Override
    public void checkLicenseNumberOrganize() {
        DdlPackBean bean = DdlPackBean.getDdlPackBean();
        DdlPreparedPack.getNumEqualPack(ImppEnumUtil.ORGANIZE_YTPE.TYPE_FACTORY.getValue(),"organizeType",bean);

        ImppLicenseTool.checkOrganize(organizeRDao.findByHqlWhereCount(bean));
    }

    @Override
    public void checkLicenseNumberLogin() {
        int count = webSessionManager.getSessionDAO().getActiveSessions().size();
        ImppLicenseTool.checkUserSession(count);
    }

}
