package cn.estsh.i3plus.core.apiservice.serviceimpl.mdm;

import cn.estsh.i3plus.core.api.iservice.busi.ISysToolService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.mdm.model.core.MdmGearCoreBusiModel;
import cn.estsh.i3plus.pojo.platform.bean.SysTool;
import cn.estsh.impp.framework.boot.mdm.cloud.IBaseMdmBusiExtdCloud;
import cn.estsh.impp.framework.boot.mdm.cloud.IBaseMdmBusiModelCloud;
import cn.estsh.impp.framework.boot.mdm.service.BaseBusiSyncMdmDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @Description :
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2020-06-03 15:08
 * @Modify:
 **/
@Component
public class SysToolSyncDataService extends BaseBusiSyncMdmDataService<SysTool, MdmGearCoreBusiModel> {

    @Autowired
    private ISysToolService sysToolService;

    @Autowired
    public SysToolSyncDataService(IBaseMdmBusiExtdCloud baseMdmBusiExtdCloud, IBaseMdmBusiModelCloud<MdmGearCoreBusiModel> baseMdmBusiModelCloud) {
        super(baseMdmBusiExtdCloud, baseMdmBusiModelCloud);
    }

    @Override
    public List<SysTool> transform(List<MdmGearCoreBusiModel> syncDataList,String userName) {
        return syncDataList.stream().map(gearCoreBusiModel -> {
            SysTool sysTool = new SysTool();
            if (gearCoreBusiModel != null && gearCoreBusiModel.getBusi() != null && gearCoreBusiModel.getMaster() != null) {
                sysTool.setId(gearCoreBusiModel.getBusi().getId());
                sysTool.setName(gearCoreBusiModel.getMaster().getName());
                sysTool.setToolIp(gearCoreBusiModel.getMaster().getGearModel());
                sysTool.setToolDescription(gearCoreBusiModel.getBusi().getCoreNum());
                ConvertBean.serviceModelInitialize(sysTool,userName);
            }
            return sysTool;
        }).collect(Collectors.toList());
    }

    @Override
    public void insertBusiList(List<SysTool> beanList) {
        for (SysTool sysTool : beanList) {
            sysToolService.insertSysTool(sysTool);
        }
    }

    @Override
    public void updateBusiList(List<SysTool> beanList) {
        for (SysTool sysTool : beanList) {
            sysToolService.updateSysTool(sysTool);
        }
    }

    @Override
    public void deleteBusiList(List<Long> id,String userName) {
        sysToolService.deleteSysToolByIds(id.toArray(new Long[id.size()]));
    }
}
